import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.MediaTracker.*;
//import java.awt.Cursor;


public class Game extends Applet implements Runnable{

int score=0;
float time=30;
float accuracy=0;
float whacks=0;

int pause=0;

Thread runner;
int loaded=0;

Image offI; Graphics offG;

Image[] hole = new Image[2];
Image[] hammer = new Image[2];
Image title;
Image boom;

int boomTicks;
int boomX=0; int boomY=0;

crittur[] crit = new crittur[11];

int hammerX; int hammerY; int hammerImg;

MediaTracker m;

Font statsFont;

public void init() {
statsFont=new Font("Helvetica",Font.BOLD,16);
setCursor(new Cursor(1));
hole[0]=getImage(getCodeBase(),"hole.gif");
hole[1]=getImage(getCodeBase(),"crittur.gif");
hammer[0]=getImage(getCodeBase(),"h1.gif");
hammer[1]=getImage(getCodeBase(),"h2.gif");
title=getImage(getCodeBase(),"title.gif");
boom=getImage(getCodeBase(),"boom.gif");

crit[0]=new crittur(0,0);
crit[1]=new crittur(400,0);

for(int count=0; count<5; ++count){
crit[count+2]=new crittur(count*100,100);
}
for(int count=0; count<4; ++count){
crit[count+7]=new crittur((count*100)+50,200);
}

m=new MediaTracker(this);

Color bgColor = new Color(57,165,255);
setBackground(bgColor);
}

public void paint(Graphics g) {
setSize(500,300);
 if(loaded==0){ g.drawString("Loading...",220,100); }
 if(loaded==1){ g.drawImage(title,150,0,this); g.drawString("Click To Start",210,100); }
  if(loaded==3){
  g.setColor(Color.blue);
  g.drawImage(title,150,0,this); g.drawString("Click To play again",180,100);
  g.drawString("Final Score:"+score,180,140);
  g.drawString("Overall accuracy:"+(int)accuracy+"%",180,160);
   String status = new String();
   if(score<10){status="You couldn't hammer through a wet tissue!";}
   if(score>10 && score<=15){status="You're lucky this isn't your job.";}
   if(score>15 && score<=20){status="Hmmm... maybe a bigger hammer would help.";}
   if(score>20 && score<=25){status="You're on the warpath!";}
   if(score>25 && score<=30){status="You're pretty mean with that hammer!";}
   if(score>30 && score<=35){status="You're good... just don't let this game influence you!";}
   if(score>35 && score<=45){status="Woah! You should gat a job as an exterminator!";}
   if(score>45){status="Expect to hear from the Animal Rights activists!!";}
   g.setColor(Color.red);
   g.drawString("Your final status:",20,190);
   g.drawString(status,20,210);
  }
  if(loaded==2){
  g.setFont(statsFont);
  g.setColor(Color.blue);
     g.drawString("Score:"+(int)score,170,60);
     g.drawString("Time:"+(int)time,170,100);
     g.drawString("Accuracy:"+(int)accuracy+"%",170,80);
     for(int count=0; count<crit.length; ++count) {
     //g.drawImage(title,150,0,this);
      if(crit[count]!=null) {
      g.drawImage(hole[crit[count].current],crit[count].x,crit[count].y,this);
      }
     }
   if(boomTicks>0){
   g.drawImage(boom,boomX,boomY,this);
   }
  g.drawImage(hammer[hammerImg],hammerX,hammerY,this);
  }
}

public void update(Graphics g) {
if(offI == null)
{
offI = createImage(600, 600);
offG = offI.getGraphics();
}
offG.clearRect(0, 0, 500, 300);
paint(offG);
g.drawImage(offI, 0, 0, null);
}


public void start() { if(runner==null) {runner=new Thread(this); runner.start(); } }

public void run() {
while(true) {
  if(loaded==0){
   try{
   m.addImage(hammer[0],0); m.waitForID(0);
   m.addImage(hammer[1],1); m.waitForID(1);
   m.addImage(hole[0],2); m.waitForID(2);
   m.addImage(hole[1],3); m.waitForID(3);
   m.addImage(title,4); m.waitForID(4);
   m.addImage(boom,5); m.waitForID(5);
   } catch(InterruptedException _e){}
   loaded=1;
  }

  if(loaded==2) {
   for(int count=0; count<crit.length; ++count) {
    if(crit[count]!=null) {
    crit[count].doStuff();
    }
   }
  if(boomTicks>0){ --boomTicks; }  
  time-=0.025;
  if(time<=0){ loaded=3; pause=100; }
  }

  if(loaded==3){
   if(pause>0){--pause;}
  }

 repaint();
 try{Thread.sleep(25);} catch(InterruptedException _e){}
 }
}


public void checkHit(int mx,int my) {
 for(int count=0; count<crit.length; ++count){
  if(hammerX+40>=crit[count].x && hammerX<crit[count].x+90 && hammerY+80>=crit[count].y+30 && hammerY+75<crit[count].y+90 && crit[count].current==1) {
  //boomX=mx-80; boomY=my+20;
  crit[count].current=0; ++score;
  boomX=crit[count].x-20; boomY=crit[count].y+40;
  boomTicks=10;
  }
 }
}

public void reload() {
time=30;
score=0;
whacks=0;
accuracy=0;
boomTicks=0;
}

public boolean mouseMove(Event evt, int mx, int my) {
hammerX=mx-40; hammerY=my-40;
return true;
}

public boolean mouseDrag(Event evt, int mx, int my) {
hammerX=mx-40; hammerY=my-40;
return true;
}

public boolean mouseDown(Event evt, int mx, int my) {
if(loaded==1 || loaded==3 && pause<=0){reload(); loaded=2;}
 else if(loaded==2) {
 ++whacks;
 checkHit(mx,my);
 accuracy=(score/whacks)*100;
 hammerImg=1;
 }
return true;
}

public boolean mouseUp(Event evt, int x, int y) {
hammerImg=0;
return true;
}


class crittur {
 int x,y;
 int current=0;
 int chance=200;

 public crittur(int x, int y) {
 this.x=x; this.y=y;
 }

 public void doStuff() {
 double rnd=Math.random()*chance;
  if((int)rnd==1){
  if(current==0){current=1;}
  else
  if(current==1){current=0;}
  }
 }
}


}